<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		ocf_forum
 */

class Hook_awards_topic
{

	/**
	 * Standard modular info function for award hooks. Provides information to allow task reporting, randomisation, and add-screen linking, to function.
	 *
	 * @return ?array	Map of award content-type info (NULL: disabled).
	 */
	function info()
	{
		if (get_forum_type()!='ocf') return NULL;

		$info=array();
		$info['connection']=$GLOBALS['FORUM_DB'];
		$info['table']='f_topics';
		$info['date_field']='t_cache_first_time';
		$info['id_field']='id';
		$info['add_url']='';
		$info['category_field']='t_forum_id';
		$info['category_type']='forums';
		$info['parent_spec__table_name']='f_forums';
		$info['parent_spec__parent_name']='f_parent_forum';
		$info['parent_spec__field_name']='id';
		$info['parent_field_name']='t_forum_id';
		$info['submitter_field']='t_cache_first_member_id';
		$info['id_is_string']=false;
		require_lang('ocf');
		$info['title']=do_lang_tempcode('SPECIFIC_FORUM_TOPICS');
		$info['validated_field']='t_validated';
		$info['category_is_string']=false;
		$info['archive_url']=build_url(array('page'=>'forumview'),get_module_zone('forumview'));
		$info['cms_page']='topics';
		$info['views_field']='t_num_views';
		$info['supports_custom_fields']=true;

		return $info;
	}

	/**
	 * Standard modular run function for award hooks. Renders a content box for an award/randomisation.
	 *
	 * @param  array		The database row for the content
	 * @param  ID_TEXT	The zone to display in
	 * @return tempcode	Results
	 */
	function run($row,$zone)
	{
		unset($zone);

		$url=build_url(array('page'=>'topicview','id'=>$row['id']),get_module_zone('topicview'));

		return do_template('SIMPLE_PREVIEW_BOX',array('TITLE'=>$row['t_cache_first_title'],'SUMMARY'=>$row['t_description'],'URL'=>$url));
	}

}


