<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		core_language_editing
 */


class Hook_do_next_menus_language
{

	/**
	 * Standard modular run function for do_next_menu hooks. They find links to put on standard navigation menus of the system.
	 *
	 * @return array			Array of links and where to show
	 */
	function run()
	{
		$has_langs=false;

		$_dir=opendir(get_file_base().'/lang/');
		$_langs=array();
		while (false!==($file=readdir($_dir)))
		{
			if ($file==fallback_lang()) continue;
			if ((!should_ignore_file('lang/'.$file,IGNORE_ACCESS_CONTROLLERS)) && (strlen($file)<=5))
				if (is_dir(get_file_base().'/lang/'.$file)) $has_langs=true;
		}
		closedir($_dir);
		if (!in_safe_mode())
		{
			$_dir=@opendir(get_custom_file_base().'/lang_custom/');
			if ($_dir!==false)
			{
				while (false!==($file=readdir($_dir)))
				{
					if ($file==fallback_lang()) continue;
					if ((!should_ignore_file('lang_custom/'.$file,IGNORE_ACCESS_CONTROLLERS)) && (strlen($file)<=5))
						if (is_dir(get_custom_file_base().'/lang_custom/'.$file)) $has_langs=true;
				}
				closedir($_dir);
			}
			if (get_custom_file_base()!=get_file_base())
			{
				$_dir=opendir(get_file_base().'/lang_custom/');
				while (false!==($file=readdir($_dir)))
				{
					if ($file==fallback_lang()) continue;
					if ((!should_ignore_file('lang_custom/'.$file,IGNORE_ACCESS_CONTROLLERS)) && (strlen($file)<=5)) $has_langs=true;
				}
				closedir($_dir);
			}
		}	

		return array(
			array('style','language',array('admin_lang',array('type'=>'misc'),get_module_zone('admin_lang')),do_lang_tempcode('TRANSLATE_CODE'),('DOC_TRANSLATE')),
			multi_lang()?array('style','language',array('admin_lang',array('type'=>'content'),get_module_zone('admin_lang')),do_lang_tempcode('TRANSLATE_CONTENT'),('DOC_TRANSLATE_CONTENT')):NULL,
			(!$has_langs)?NULL:array('style','criticise_language',array('admin_lang',array('type'=>'criticise'),get_module_zone('admin_lang')),do_lang_tempcode('CRITICISE_LANGUAGE_PACK'),('DOC_CRITICISE_LANGUAGE_PACK')),
		);
	}

}


